package psoo.math.geometrie;

import psoo.math.util.Point;

public class Couronne extends Disque implements Cloneable {
	private double rayonInterne;

	public Couronne(Point c, double r1, double r2) {
		super(c, r1);
		if (r2 < r1)
			rayonInterne = r2;
		else throw new RuntimeException("Rayon interne incorrect");
	}

	public Couronne(Couronne c) 
	{
		this(new Point(c.centre), c.r1, c.rayonInterne);
	}

	
	public double aire()
	{
		return Math.PI * (r1 * r1 - rayonInterne * rayonInterne) ;
	}

	public boolean equal(Object o)
	{
		if (o != null && o.getClass().equals(getClass()))
		{
			Couronne c = (Couronne)o;
			return (super.equals(c) && rayonInterne == c.rayonInterne); 
		}
		return false;
	}
	
	
	public String toString()
	{
		return "[ centre : " + centre + ", rayon externe = " + r1 + " rayon interne = " + rayonInterne + " ]";
	}	
}

