package psoo.math.geometrie;

import psoo.math.util.Point;
import psoo.math.util.VecteurDuPlan;

public class Ellipse extends FigurePlan {
	protected double r1, r2;
	protected Point centre;
	public Ellipse(Point c, double r1, double r2) {
		centre = c;
		this.r1 = r1;
		this.r2 = r2;
	}
	
	
	public Ellipse(Ellipse e)
	{
		this(new Point(e.centre), e.r1, e.r2);
	}

	public void translation(VecteurDuPlan v)
	{
		centre = new Point(centre.getX() + v.coordCartesienne(0), centre.getY() + v.coordCartesienne(1));
	}

	public double aire() {
		
		return Math.PI * r1 * r2;
	}

	
	public boolean equals(Object o)
	{
		if (o != null && o.getClass().equals(getClass()))
		{
			Ellipse d = (Ellipse)o;
			return (centre.equals(d.centre) && ((r1 == d.r1 && r2 == d.r2) || (r2 == d.r1 && r1 == d.r2))); 
		}
		return false;
	}
	

	public String toString()
	{
		return "[ centre : " + centre + ", rayon1 = " + r1 + ", rayon2 = " + r2 + " ] ";
	}	
}



