package psoo.math.geometrie;

import psoo.math.util.Point;
import psoo.math.util.VecteurDuPlan;

public class Polygone extends FigurePlan {
	protected int nbSommets;
	protected Point[] sommets;
	
	public Polygone()
	{
		nbSommets = 0;
	}
	
	public Polygone(double[] x, double[] y) 
	{
		construit(x, y);
	}

	public Polygone(Polygone p)
	{
		nbSommets = p.nbSommets;
		sommets = p.sommets.clone();
	}
	
	protected void construit(double[] x, double[] y)
	{
		if (x.length == y.length)
		{
			
				nbSommets = x.length;
				sommets = new Point[nbSommets + 1];
				for(int i = 0; i < nbSommets ; i++)
						sommets[i] = new Point(x[i], y[i]);
				sommets[nbSommets] = sommets[0]; 
		}
		else throw new RuntimeException("Pb taille tableau");
	}
	
	public double aire() {
	double s = 0;
	for(int i = 0; i < nbSommets ; i++)
		s += sommets[i].getX() * sommets[i+1].getY() - sommets[i+1].getX() * sommets[i].getY();
	return Math.abs(s/2);
	}
	
	
	public String toString()
	{
		String s = "[ ";
		for(int i = 0; i < nbSommets; i++)
			s = s + sommets[i] + (i == nbSommets - 1 ? " ]" : ", ");
		return s;		
	}
	
	
	public void translation(VecteurDuPlan v)
	{
		for(int i = 0 ; i <= nbSommets; i++)
			sommets[i] = new Point(sommets[i].getX() + v.coordCartesienne(0), sommets[i].getY() + v.coordCartesienne(1));
	}
	
	
	public boolean equals(Polygone p)
	/* Ce n'est pas très propre, cela considère que deux polygones sont égaux s'ils ont les
	 * mêmes sommets et énuméré de la même façon
	 */
	{
		if (nbSommets != p.nbSommets)
			return false;
		else for(int i= 0; i < nbSommets; i++)
				if (! sommets[i].equals(p.sommets[i]))
					return false;
		return true;
	}
	
	public static void main(String[] args) 
	{
		double x[] = {2, 2, 1, 1};
		double y[] = {1, 2, 2, 1};
		Polygone p = new Polygone(x, y);
		System.out.println("Polygone " + p);
		System.out.println("Surface = " + p.aire());
		p.translation(new VecteurDuPlan(2,2));
		System.out.println("Polygone " + p);
		System.out.println("Surface = " + p.aire());
		Polygone p2 = new Polygone(p);
		System.out.println("Polygone " + p);
		if (p.equals(p2))
			System.out.println("OK");
	}

}

