package psoo.math.geometrie;

import psoo.math.util.Point;

public class PolygoneRegulier extends Polygone implements Regulier {

	public PolygoneRegulier(Polygone p) {
		super(p);
	}
	
	public PolygoneRegulier(int nbSommets, Point c, Point p)
	{
		super();
		double dx = p.getX() - c.getX();
		double dy = p.getY() - c.getY();
		double r = Math.sqrt(dx*dx + dy*dy);
		double alpha = Math.atan(dy/dx);
		this.nbSommets = nbSommets;
		sommets = new Point[nbSommets + 1];
		double xi, yi;
		for(int i = 0; i < nbSommets; i++)
		{
			xi = c.getX() + r * Math.cos(alpha + i * 2 * Math.PI / nbSommets);
			yi = c.getY() + r * Math.sin(alpha + i * 2 * Math.PI / nbSommets);
			sommets[i] = new Point(xi, yi);
		}
		sommets[nbSommets] = new Point(sommets[0].getX(), sommets[0].getY());
	}

	
	public static void main(String[] args) 
	{
		PolygoneRegulier p = new PolygoneRegulier(4, new Point(1,1), new Point(0,0));
		System.out.println("Polygone regulier : " + p + "aire : " + p.aire());
	}


}
