package psoo.math.geometrie;

import psoo.math.util.Point;
import psoo.math.util.VecteurDuPlan;

public class TestFigure {


	public static void main(String[] args) {
		Point origine = new Point(0, 0);
		Ellipse e1 = new Ellipse(origine, 10, 3);
		System.out.println("Ellipse e1 : " + e1);
		System.out.println("- Aire ellipse e1 : " + e1.aire());

		Disque d1 = new Disque(origine, 10);
		System.out.println("Disque d1 : " + d1);
		System.out.println("- Aire disque d1 : " + d1.aire());

		if (d1.compareTo(e1) > 0)
			System.out.println("--> d1 plus grand que e1");
		
		Couronne c1 = new Couronne(origine, 10, 8);
		// Couronne c1 = new Couronne(origine, 8, 10); Exception !
		System.out.println("Coronne c1 : " + c1);
		System.out.println("- Aire couronne c1 : " + c1.aire());
		
		double x[] = {2, 2, 1, 1};
		double y[] = {1, 2, 2, 1};
		Polygone p1 = new Polygone(x, y);
		System.out.println("Polygone p1 : " + p1);
		System.out.println("- Aire polygone p1 : " + p1.aire());
		Polygone oldp1 = new Polygone(p1);
		p1.translation(new VecteurDuPlan(2,2));
		System.out.println("-- Polygone p1 translaté : " + p1);
		System.out.println("- Aire polygone p1 après translation " + p1.aire());
		System.out.println("Polygone oldp1" + oldp1);
		if (p1.equals(oldp1))
			System.out.println("Erreur");
		if (p1.compareTo(oldp1) == 0)
			System.out.println("--> Même taille ");
		
		PolygoneRegulier pr1 = new PolygoneRegulier(4, new Point(1,1), new Point(0,0));
		System.out.println("Polygone regulier pr1 : " + pr1);
		System.out.println("- Aire polygone régulier pr1 : " + pr1.aire());
		pr1.translation(new VecteurDuPlan(1,1));
		System.out.println("Polygone regulier après trans : " + pr1);
		System.out.println("- Aire polygone régulier pr1 après trans : " + pr1.aire());

		Triangle t1 = new Triangle(new Point(0,0), new Point(2, 2), new Point(0, 2));
		System.out.println("Triangle t1 : " + t1);
		System.out.println("- Aire triangle t1 : " + t1.aire());

		FigurePlan r1 = new Rectangle(origine, 10, 2); // Un rectangle est une FigurePlan
		System.out.println("Rectangle r1: " + r1);
	
		Carre ca1 = new Carre(origine, 10); 
		System.out.println("Carré ca1: " + ca1);
		
		Regulier[] figRegulieres = new Regulier[2];
		figRegulieres[0] = pr1; figRegulieres[1] = ca1;
		
		double surface = 0;
		for(int i = 0; i < figRegulieres.length; i++)
			surface += ((FigurePlan)figRegulieres[i]).aire();
		System.out.println("Surface des figures régulières : " + surface);
	}

}
